import _regeneratorRuntime from 'babel-runtime/regenerator';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

// require (PrototypeArray.js), 使用了: deepTree, getDeepTreeNodesByNames
import React, { useContext, useState, useEffect, useRef, forwardRef } from 'react';
import { createPortal } from 'react-dom';
import Context from '../Context/instance.js';
import treeData from './china.js';

// 数据
var initTabs = []; // 根据key或者name获取tabs, property用于区分是key还是value比较
// 选中项[{id: '', name: ''}]
var currentSelected = null;
// 国家
var currentCountries = null;
// 省市区
var currentData = null;
// 街道临时存储
var currentStreets = [];

var PickerDistrict = forwardRef(function (_ref, ref) {
  // eslint-disable-line
  // 第一步: 获取国家和省市区
  var loadCurrentData = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var countriesSuccess;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(countries || typeof getCountries === 'function')) {
                _context.next = 6;
                break;
              }

              _context.next = 3;
              return loadCountries();

            case 3:
              countriesSuccess = _context.sent;

              if (countriesSuccess) {
                _context.next = 6;
                break;
              }

              return _context.abrupt('return');

            case 6:
              _context.next = 8;
              return loadData();

            case 8:
              _context.next = 10;
              return loadSelected();

            case 10:
              // 初始化tabbar
              initTabBar();
              // 渲染页面
              if (currentCountries && currentCountries.length || currentData && currentData.length) {
                initList();
              }

            case 12:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function loadCurrentData() {
      return _ref2.apply(this, arguments);
    };
  }();
  // 第二步: 获取选中数据


  var loadSelected = function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
      var _this = this;

      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.abrupt('return', new Promise(function () {
                var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(resolve) {
                  var _iterator, _isArray, _i, _ref5, item, values, country, districtOption, streetName, success, _iterator2, _isArray2, _i2, _ref6, street;

                  return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          if (!(selected && selected.length)) {
                            _context2.next = 22;
                            break;
                          }

                          _iterator = selected, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();

                        case 2:
                          if (!_isArray) {
                            _context2.next = 8;
                            break;
                          }

                          if (!(_i >= _iterator.length)) {
                            _context2.next = 5;
                            break;
                          }

                          return _context2.abrupt('break', 19);

                        case 5:
                          _ref5 = _iterator[_i++];
                          _context2.next = 12;
                          break;

                        case 8:
                          _i = _iterator.next();

                          if (!_i.done) {
                            _context2.next = 11;
                            break;
                          }

                          return _context2.abrupt('break', 19);

                        case 11:
                          _ref5 = _i.value;

                        case 12:
                          item = _ref5;

                          if (!(!item.id || !item.name)) {
                            _context2.next = 17;
                            break;
                          }

                          currentSelected = null;
                          resolve(currentSelected);
                          return _context2.abrupt('return', currentSelected);

                        case 17:
                          _context2.next = 2;
                          break;

                        case 19:
                          currentSelected = selected;
                          resolve(currentSelected);
                          return _context2.abrupt('return', currentSelected);

                        case 22:

                          // 没有选中数据从value中取
                          values = [];

                          if (value && value.split(split)) {
                            values = value.split(split);
                          }

                          if (!(!values || !values.length)) {
                            _context2.next = 28;
                            break;
                          }

                          currentSelected = null;
                          resolve(currentSelected);
                          return _context2.abrupt('return', currentSelected);

                        case 28:

                          currentSelected = null;
                          // 如果有国家
                          if (Array.isArray(currentCountries) && currentCountries.length) {
                            country = getCountryByName(values.shift());

                            if (country) currentSelected = [country];
                          }
                          // 没有城市数据返回直接返回

                          if (!(!currentData || !currentData.length)) {
                            _context2.next = 33;
                            break;
                          }

                          resolve(currentSelected);
                          return _context2.abrupt('return', currentSelected);

                        case 33:
                          // 根据values取出选中数据
                          currentSelected = (currentSelected || []).concat(currentData.getDeepTreeNodesByNames(values));
                          // 如果有街道时长度会不一致, 则需要查询街道

                          if (!(currentSelected && currentSelected.length && currentSelected.length === (currentCountries && currentCountries.length ? values.length : values.length - 1))) {
                            _context2.next = 60;
                            break;
                          }

                          districtOption = currentSelected[currentSelected.length - 1]; // 获取区数据

                          streetName = values[values.length - 1]; // 获取街道名

                          _context2.next = 39;
                          return loadStreets(districtOption.id);

                        case 39:
                          success = _context2.sent;

                          if (!(success && (!Array.isArray(currentStreets) || !currentStreets || !currentStreets.length))) {
                            _context2.next = 43;
                            break;
                          }

                          resolve(currentSelected);
                          return _context2.abrupt('return', currentSelected);

                        case 43:
                          _iterator2 = currentStreets, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();

                        case 44:
                          if (!_isArray2) {
                            _context2.next = 50;
                            break;
                          }

                          if (!(_i2 >= _iterator2.length)) {
                            _context2.next = 47;
                            break;
                          }

                          return _context2.abrupt('break', 60);

                        case 47:
                          _ref6 = _iterator2[_i2++];
                          _context2.next = 54;
                          break;

                        case 50:
                          _i2 = _iterator2.next();

                          if (!_i2.done) {
                            _context2.next = 53;
                            break;
                          }

                          return _context2.abrupt('break', 60);

                        case 53:
                          _ref6 = _i2.value;

                        case 54:
                          street = _ref6;

                          if (!(street.name === streetName)) {
                            _context2.next = 58;
                            break;
                          }

                          currentSelected.push(street);
                          return _context2.abrupt('break', 60);

                        case 58:
                          _context2.next = 44;
                          break;

                        case 60:
                          resolve(currentSelected);
                          return _context2.abrupt('return', currentSelected);

                        case 62:
                        case 'end':
                          return _context2.stop();
                      }
                    }
                  }, _callee2, _this);
                }));

                return function (_x) {
                  return _ref4.apply(this, arguments);
                };
              }()));

            case 1:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    return function loadSelected() {
      return _ref3.apply(this, arguments);
    };
  }();
  // 第三步: 初始化tabs


  // 第四步: 结合选中数据, 初始化列表
  var initList = function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
      var initList;
      return _regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              initList = [];
              // 选中国家与选中省市区有些区别, 选中国家需要直接显示省份

              if (!(initTabs.length <= 2 && currentCountries && currentCountries.length)) {
                _context4.next = 11;
                break;
              }

              if (!(initTabs.length === 2)) {
                _context4.next = 8;
                break;
              }

              _context4.next = 5;
              return loadData(initTabs[initTabs.length - 2].id);

            case 5:
              if (currentData) initList = currentData;
              _context4.next = 9;
              break;

            case 8:
              if (initTabs.length === 1) {
                // 没有选中国家, 显示国家列表
                initList = currentCountries;
              }

            case 9:
              _context4.next = 16;
              break;

            case 11:
              // 选中省市区街道, 则显示当前选中的层级列表
              initList = getParentChildren(initTabs[initTabs.length - 1].parentid || '');

              if (!(!initList && initTabs[initTabs.length - 2].id)) {
                _context4.next = 16;
                break;
              }

              _context4.next = 15;
              return loadStreets(initTabs[initTabs.length - 2].id);

            case 15:
              if (currentStreets && currentStreets.length) initList = currentStreets;

            case 16:
              setList(initList);

            case 17:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    return function initList() {
      return _ref7.apply(this, arguments);
    };
  }();

  // 工具方法: 获取国家, 失败返回false, 成功返回true


  var loadCountries = function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
      var _this2 = this;

      return _regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              return _context6.abrupt('return', new Promise(function () {
                var _ref10 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5(resolve) {
                  return _regeneratorRuntime.wrap(function _callee5$(_context5) {
                    while (1) {
                      switch (_context5.prev = _context5.next) {
                        case 0:
                          if (!(Array.isArray(countries) && countries.length)) {
                            _context5.next = 9;
                            break;
                          }

                          if (!(countries[0].id && countries[0].name)) {
                            _context5.next = 5;
                            break;
                          }

                          currentCountries = formatCountries(countries);
                          resolve(currentCountries);
                          return _context5.abrupt('return', currentCountries);

                        case 5:
                          currentCountries = null;
                          resolve(currentCountries);
                          setErrMsg('countries' + locale('参数不正确', 'wrong_parameter'));
                          return _context5.abrupt('return', currentCountries);

                        case 9:
                          if (getCountries) {
                            _context5.next = 13;
                            break;
                          }

                          currentCountries = null;
                          resolve(currentCountries);
                          return _context5.abrupt('return', currentCountries);

                        case 13:
                          // 有获取国家的方法时, 加载国家数据
                          setLoading(true);
                          _context5.prev = 14;
                          _context5.next = 17;
                          return getCountries();

                        case 17:
                          currentCountries = _context5.sent;
                          _context5.next = 27;
                          break;

                        case 20:
                          _context5.prev = 20;
                          _context5.t0 = _context5['catch'](14);

                          setErrMsg(locale('获取数据失败', 'hint_getdata_failed'));
                          setLoading(false);
                          currentCountries = null;
                          resolve(currentCountries);
                          return _context5.abrupt('return');

                        case 27:
                          setLoading(false);
                          // 返回字符串, 说明有错

                          if (!(typeof currentCountries === 'string')) {
                            _context5.next = 33;
                            break;
                          }

                          setErrMsg(currentCountries);
                          currentCountries = null;
                          resolve(currentCountries);
                          return _context5.abrupt('return');

                        case 33:
                          if (!(!currentCountries || currentCountries instanceof Array === false)) {
                            _context5.next = 37;
                            break;
                          }

                          currentCountries = null;
                          resolve(currentCountries);
                          return _context5.abrupt('return');

                        case 37:
                          resolve(formatCountries(currentCountries));

                        case 38:
                        case 'end':
                          return _context5.stop();
                      }
                    }
                  }, _callee5, _this2, [[14, 20]]);
                }));

                return function (_x2) {
                  return _ref10.apply(this, arguments);
                };
              }()));

            case 1:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    return function loadCountries() {
      return _ref9.apply(this, arguments);
    };
  }();

  // 工具方法: 获取省市区


  var loadData = function () {
    var _ref11 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee8(id) {
      var _this3 = this;

      return _regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              return _context8.abrupt('return', new Promise(function () {
                var _ref12 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7(resolve) {
                  var countryName, country, newData, dataStr;
                  return _regeneratorRuntime.wrap(function _callee7$(_context7) {
                    while (1) {
                      switch (_context7.prev = _context7.next) {
                        case 0:
                          if (!(Array.isArray(currentCountries) && currentCountries.length)) {
                            _context7.next = 6;
                            break;
                          }

                          // 获取选中国家的id, 用于获取此国家下的省市区
                          if (!id && (value || selected)) {
                            if (Array.isArray(selected) && selected.length) {
                              id = selected[0].id;
                            } else if (value) {
                              countryName = value.split(split)[0];
                              country = getCountryByName(countryName);

                              if (country && country.id) id = country.id;
                            }
                          }
                          // 没有国家id, 说明还没有选中的国家

                          if (id) {
                            _context7.next = 6;
                            break;
                          }

                          currentData = null;
                          resolve(currentData);
                          return _context7.abrupt('return', currentData);

                        case 6:
                          // 获取省市区
                          newData = null;

                          if (!(typeof getData === 'function')) {
                            _context7.next = 17;
                            break;
                          }

                          setLoading(true);
                          _context7.next = 11;
                          return getData(id);

                        case 11:
                          newData = _context7.sent;

                          if (typeof newData === 'string') {
                            setErrMsg(newData);
                          }
                          if (!newData) {
                            setErrMsg(locale('获取数据失败', 'hint_getdata_failed'));
                          }
                          setLoading(false);
                          _context7.next = 18;
                          break;

                        case 17:
                          if (Array.isArray(data)) {
                            newData = data;
                          }

                        case 18:
                          // 格式化数据
                          if (newData && newData.length && dataFormat && (dataFormat.parentPropertyName || dataFormat.namePropertyName || dataFormat.idPropertyName || dataFormat.childPropertyName)) {
                            try {
                              dataStr = JSON.stringify(newData);

                              if (dataFormat.parentPropertyName) {
                                dataStr = dataStr.replace(new RegExp(dataFormat.parentPropertyName, 'igm'), 'parentid');
                              }
                              if (dataFormat.namePropertyName) {
                                dataStr = dataStr.replace(new RegExp(dataFormat.namePropertyName, 'igm'), 'name');
                              }
                              if (dataFormat.idPropertyName) {
                                dataStr = dataStr.replace(new RegExp(dataFormat.idPropertyName, 'igm'), 'id');
                              }
                              if (dataFormat.childPropertyName) {
                                dataStr = dataStr.replace(new RegExp(dataFormat.childPropertyName, 'igm'), 'parentid');
                              }
                              newData = JSON.parse(dataStr);
                            } catch (error) {
                              newData = null;
                            }
                          }
                          if (newData && newData.length) {
                            currentData = newData.deepTree();
                          } else {
                            currentData = null;
                          }
                          resolve(currentData);

                        case 21:
                        case 'end':
                          return _context7.stop();
                      }
                    }
                  }, _callee7, _this3);
                }));

                return function (_x4) {
                  return _ref12.apply(this, arguments);
                };
              }()));

            case 1:
            case 'end':
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));

    return function loadData(_x3) {
      return _ref11.apply(this, arguments);
    };
  }();

  // 工具方法: 获取街道, 失败返回false, 成功返回true


  var loadStreets = function () {
    var _ref13 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee10(id) {
      var _this4 = this;

      return _regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              return _context10.abrupt('return', new Promise(function () {
                var _ref14 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee9(resolve) {
                  return _regeneratorRuntime.wrap(function _callee9$(_context9) {
                    while (1) {
                      switch (_context9.prev = _context9.next) {
                        case 0:
                          setLoading(true);
                          _context9.prev = 1;
                          _context9.next = 4;
                          return getStreets(id);

                        case 4:
                          currentStreets = _context9.sent;
                          _context9.next = 14;
                          break;

                        case 7:
                          _context9.prev = 7;
                          _context9.t0 = _context9['catch'](1);

                          setErrMsg(locale('获取数据失败', 'hint_getdata_failed'));
                          setLoading(false);
                          currentStreets = null;
                          resolve(currentStreets);
                          return _context9.abrupt('return');

                        case 14:
                          setLoading(false);
                          // 返回字符串, 说明有错

                          if (!(typeof currentStreets === 'string')) {
                            _context9.next = 20;
                            break;
                          }

                          setErrMsg(currentStreets);
                          currentStreets = null;
                          resolve(currentStreets);
                          return _context9.abrupt('return');

                        case 20:
                          if (!(!currentStreets || currentStreets instanceof Array === false)) {
                            _context9.next = 24;
                            break;
                          }

                          currentStreets = null;
                          resolve(currentStreets);
                          return _context9.abrupt('return');

                        case 24:
                          // 增加街道标识
                          currentStreets = (currentStreets || []).map(function (street) {
                            street.isStreet = true;
                            return street;
                          });
                          resolve(currentStreets);

                        case 26:
                        case 'end':
                          return _context9.stop();
                      }
                    }
                  }, _callee9, _this4, [[1, 7]]);
                }));

                return function (_x6) {
                  return _ref14.apply(this, arguments);
                };
              }()));

            case 1:
            case 'end':
              return _context10.stop();
          }
        }
      }, _callee10, this);
    }));

    return function loadStreets(_x5) {
      return _ref13.apply(this, arguments);
    };
  }();

  // 如果列表发生变化, 则查找选中项


  // 点击选项
  var onClickOption = function () {
    var _ref16 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee11(e, option) {
      var tabLen, spliceTabs;
      return _regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              // 截取tabs
              tabLen = tabIndex + 1;
              spliceTabs = Object.clone(tabs).splice(0, tabLen);

              // 修改当前选中项

              spliceTabs[tabIndex] = option;

              // 因为useState是异步的, 直接提交会提交上一次的值
              tabs = spliceTabs;

              // 如果设置类型为省市区, 则直接提交

              if (!isLeaf()) {
                _context11.next = 8;
                break;
              }

              setTabs(spliceTabs);
              onSubmit(e, option);
              return _context11.abrupt('return');

            case 8:
              if (!option.isCountry) {
                _context11.next = 14;
                break;
              }

              _context11.next = 11;
              return loadData(option.id);

            case 11:
              // 设置下级list
              setList(currentData);
              _context11.next = 31;
              break;

            case 14:
              if (!(!option.children || !option.children.length)) {
                _context11.next = 30;
                break;
              }

              if (!(!option.isStreet && getStreets)) {
                _context11.next = 27;
                break;
              }

              _context11.next = 18;
              return loadStreets(option.id);

            case 18:
              if (!(!Array.isArray(currentStreets) || !currentStreets || !currentStreets.length)) {
                _context11.next = 22;
                break;
              }

              setTabs(spliceTabs);
              onSubmit(e, option);
              return _context11.abrupt('return');

            case 22:
              setList(currentStreets);

              // 设置tabs
              // spliceTabs[spliceTabs.length - 1].name = option.name
              spliceTabs.push({
                parentid: option.id,
                id: '',
                name: '请选择'
              });
              setTabs(spliceTabs);
              setTabIndex(spliceTabs.length - 1);
              return _context11.abrupt('return');

            case 27:
              // 街道直接提交
              setTabs(spliceTabs);
              onSubmit(e, option);
              return _context11.abrupt('return');

            case 30:
              // 设置下级list
              setList(option.children);

            case 31:

              // 补充请选择的空项
              spliceTabs.push({
                parentid: '',
                id: '',
                name: '请选择'
              });

              setTabs(spliceTabs);
              setTabIndex(tabLen);

            case 34:
            case 'end':
              return _context11.stop();
          }
        }
      }, _callee11, this);
    }));

    return function onClickOption(_x7, _x8) {
      return _ref16.apply(this, arguments);
    };
  }();

  var portal = _ref.portal,
      countries = _ref.countries,
      getCountries = _ref.getCountries,
      _ref$data = _ref.data,
      data = _ref$data === undefined ? treeData : _ref$data,
      dataFormat = _ref.dataFormat,
      getData = _ref.getData,
      _ref$firstStageCitys = _ref.firstStageCitys,
      firstStageCitys = _ref$firstStageCitys === undefined ? ['北京', '天津', '上海', '重庆'] : _ref$firstStageCitys,
      _ref$split = _ref.split,
      split = _ref$split === undefined ? '-' : _ref$split,
      _ref$type = _ref.type,
      type = _ref$type === undefined ? '' : _ref$type,
      show = _ref.show,
      value = _ref.value,
      selected = _ref.selected,
      _ref$maskAttribute = _ref.maskAttribute,
      maskAttribute = _ref$maskAttribute === undefined ? {} : _ref$maskAttribute,
      _ref$submitAttribute = _ref.submitAttribute,
      submitAttribute = _ref$submitAttribute === undefined ? {} : _ref$submitAttribute,
      _ref$cancelAttribute = _ref.cancelAttribute,
      cancelAttribute = _ref$cancelAttribute === undefined ? {} : _ref$cancelAttribute,
      getStreets = _ref.getStreets,
      others = _objectWithoutProperties(_ref, ['portal', 'countries', 'getCountries', 'data', 'dataFormat', 'getData', 'firstStageCitys', 'split', 'type', 'show', 'value', 'selected', 'maskAttribute', 'submitAttribute', 'cancelAttribute', 'getStreets']);

  // 声明ref
  var refElBody = useRef(null);
  // context
  var context = useContext(Context) || {};
  var locale = context.locale || function (remark) {
    return remark || '';
  };

  // 页签和列表

  var _useState = useState([]),
      tabs = _useState[0],
      setTabs = _useState[1];

  var _useState2 = useState(0),
      tabIndex = _useState2[0],
      setTabIndex = _useState2[1];

  var _useState3 = useState([]),
      list = _useState3[0],
      setList = _useState3[1];

  var _useState4 = useState(''),
      errMsg = _useState4[0],
      setErrMsg = _useState4[1];

  var _useState5 = useState(false),
      loading = _useState5[0],
      setLoading = _useState5[1];

  // 设置列表, 如果类型为省时, 则不显示直辖市, 类型为市时, 则不显示直辖市的区


  function isLeaf() {
    // 判断点击的是否是底层
    if (type === 'country') {
      if (tabIndex === 0) return true;
    }
    // 没有国家且为中国行政区划时才生效, 因为只有中国有省市区
    if (!currentCountries || !currentCountries.length) {
      if (type === 'province') {
        if (tabIndex === 0) return true;
      } else if (type === 'city') {
        if (tabIndex === 1) return true;
        // 直辖市特别市没有省, 为0级节点
        if (firstStageCitys.indexOf(tabs[0].name.replace('市', '')) !== -1) {
          return true;
        }
      } else if (type === 'district') {
        if (tabIndex === 2) return true;
        // 直辖市特别市没有省, 它们的区为1级节点
        if (tabIndex === 1 && firstStageCitys.indexOf(tabs[0].name) !== -1) {
          return true;
        }
      }
    }
    return false;
  }

  // 获取省市区父节点下所有的子节点
  function getParentChildren(parentid) {
    if (!parentid || parentid === '-1') {
      return currentData;
    }
    if (currentData && currentData.length) {
      var parent = currentData.getDeepTreeNode(parentid);
      return parent.children;
    }
    setErrMsg(locale('暂无数据', 'no_data'));
    return [];
  }

  // 数据初始化
  useEffect(function () {
    if (show) {
      loadCurrentData();
    }
  }, [show]);function initTabBar() {
    initTabs = [];
    if (currentSelected && currentSelected.length) {
      initTabs = Object.clone(currentSelected);
    }
    if (initTabs && initTabs.length) {
      if (!initTabs[initTabs.length - 1].name) {
        initTabs[initTabs.length - 1].name = '请选择';
      }
    } else {
      initTabs[0] = {
        parentid: '',
        id: '',
        name: '请选择'
      };
    }
    // 选中国家与选中省市区有些区别, 选中国家需要直接显示省份, 所以要默认增加一项
    if (initTabs.length === 1 && type !== 'country' && initTabs[0].id && currentCountries && currentCountries.length) {
      initTabs.push({
        parentid: '',
        id: '',
        name: '请选择'
      });
    }
    setTabs(initTabs);
    setTabIndex(initTabs.length - 1);
  }function formatCountries(list) {
    return (list || []).map(function (item) {
      item.isCountry = true;
      return item;
    });
  }
  function getCountryByName(countryName) {
    for (var _iterator3 = currentCountries, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
      var _ref8;

      if (_isArray3) {
        if (_i3 >= _iterator3.length) break;
        _ref8 = _iterator3[_i3++];
      } else {
        _i3 = _iterator3.next();
        if (_i3.done) break;
        _ref8 = _i3.value;
      }

      var item = _ref8;

      if (item.name.indexOf(countryName) !== -1 || countryName.indexOf(item.name) !== -1) {
        return item;
      }
    }
    return null;
  }
  useEffect(function () {
    if (!refElBody || !refElBody.current) {
      return;
    }
    var activeEl = refElBody.current.querySelector('.active');
    if (activeEl) {
      refElBody.current.scrollTop = activeEl.offsetTop - activeEl.clientHeight * 2 - 20;
    }
  }, [list]);

  // 点击面板
  function onClickPanel(e) {
    e.stopPropagation();
  }
  // 点击tab
  function onClickTab(tab, index) {
    setErrMsg('');
    // 点击街道
    if (tab.isStreet && currentStreets && currentStreets.length) {
      setTabIndex(index);
      setList(currentStreets);
      return;
    }
    // 点击国家
    if (index === 0 && currentCountries && currentCountries.length) {
      setTabIndex(index);
      setList(currentCountries);
      return;
    }
    // 点击省(有国家的情况下), 其parentid为国家id, 所以在currentData里找不到数据
    if (index === 1 && currentCountries && currentCountries.length) {
      setTabIndex(index);
      setList(currentData);
      return;
    }

    // 点击省市区
    var children = getParentChildren(tab.parentid);
    // 点击末级“请选择”, 直接获取上级的children
    if (index === tabs.length - 1 && !tab.parentid && tabs.length > 1) {
      children = getParentChildren(tabs[index - 1].id);
    }

    if (children) {
      setTabIndex(index);
      setList(children);
    }
  }
  // 构建选中项
  function getOptions(lastOption) {
    var options = Object.clone(tabs);
    options[options.length - 1] = lastOption;
    return options;
  }
  function getOptionsStr(options) {
    var val = [];
    for (var _iterator4 = options, _isArray4 = Array.isArray(_iterator4), _i4 = 0, _iterator4 = _isArray4 ? _iterator4 : _iterator4[Symbol.iterator]();;) {
      var _ref15;

      if (_isArray4) {
        if (_i4 >= _iterator4.length) break;
        _ref15 = _iterator4[_i4++];
      } else {
        _i4 = _iterator4.next();
        if (_i4.done) break;
        _ref15 = _i4.value;
      }

      var option = _ref15;

      val.push(option.name);
    }
    return val.join(split);
  }
  // 提交
  function onSubmit(e, option) {
    var options = getOptions(option);
    var optionsStr = getOptionsStr(options);
    if (submitAttribute && submitAttribute.onClick) {
      submitAttribute.onClick(e, optionsStr, options);
    }
  }
  return createPortal(React.createElement(
    'div',
    _extends({
      ref: ref
    }, maskAttribute, {
      className: 'mask picker-district-mask' + (maskAttribute.className ? ' ' + maskAttribute.className : '') + (show ? ' active' : '')
    }),
    React.createElement(
      'div',
      _extends({
        'data-animation': 'slideUp'
      }, others, {
        className: 'picker-district' + (others.className ? ' ' + others.className : ' popup-animation bottom-center') + (show ? ' active' : ''),
        onClick: onClickPanel
      }),
      React.createElement(
        'div',
        { className: 'picker-district-header' },
        '\u8BF7\u9009\u62E9\u6240\u5728\u5730\u533A'
      ),
      React.createElement(
        'div',
        { className: 'picker-district-tabbar' },
        tabs.map(function (tab, index) {
          return React.createElement(
            'div',
            { onClick: function onClick() {
                return onClickTab(tab, index);
              }, className: 'picker-district-tab' + (index === tabIndex ? ' active' : ''), key: index },
            tab.name
          );
        })
      ),
      React.createElement(
        'div',
        { className: 'picker-district-body', ref: refElBody },
        list && list.map(function (item, index) {
          return React.createElement(
            'div',
            { key: index, onClick: function onClick(e) {
                return onClickOption(e, item);
              }, className: 'picker-district-option' + (tabs[tabIndex] && tabs[tabIndex].id === item.id ? ' active' : '') },
            React.createElement('div', { className: 'picker-district-option-icon' }),
            React.createElement(
              'div',
              { className: 'picker-district-option-caption' },
              item.name
            )
          );
        })
      ),
      errMsg && React.createElement(
        'div',
        { className: 'picker-district-error' },
        React.createElement('div', { className: 'picker-district-error-icon' }),
        React.createElement(
          'div',
          { className: 'picker-district-error-label' },
          errMsg
        )
      ),
      loading && React.createElement(
        'div',
        { className: 'picker-district-load' },
        React.createElement('div', { className: 'picker-district-load-icon' }),
        React.createElement(
          'div',
          { className: 'picker-district-load-label' },
          locale('加载中...', 'in_loading')
        )
      )
    )
  ), portal || context.portal || document.getElementById('root') || document.body);
});

export default PickerDistrict;